=== debian/changelog ===
xdaliclock (2.44+debian-3) unstable; urgency=low

  * debian/rules:
    + Use autoreconf to regenerate configure (Closes: #941035)
  * debian/control:
    + Updated Standards-Version to 4.6.1
    + Switched to debhelper-compat.
    + Added 'Rules-Requires-Root' field.
  * Updated debian/watch.

 -- Kartik Mistry <kartik@debian.org>  Mon, 18 Jul 2022 08:07:19 +0530

xdaliclock (2.44+debian-2) unstable; urgency=low

  * debian/patches/cross.patch:
    + Added patch to fix FTBFS with cross compilation. Thanks to Helmut Grohne.
      (Closes: #941035)

 -- Kartik Mistry <kartik@debian.org>  Tue, 24 Sep 2019 07:54:33 +0530

xdaliclock (2.44+debian-1) unstable; urgency=low

  * New upstream release.
  * debian/control:
    + Updated Standards-Version to 4.4.0
  * Added Salsa CI Pipeline config.
  * debian/rules:
    + Added CPPFLAGS.
  * Bumped dh to 12.

 -- Kartik Mistry <kartik@debian.org>  Thu, 19 Sep 2019 13:44:25 +0400
