=== debian/control ===
Source: xdaliclock
Section: x11
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dpkg-dev (>= 1.16.1.1),
               libx11-dev,
               libxext-dev,
               libxt-dev,
               x11proto-core-dev
Maintainer: Kartik Mistry <kartik@debian.org>
Standards-Version: 4.6.1
Homepage: https://www.jwz.org/xdaliclock/
Vcs-Git: https://salsa.debian.org/debian/xdaliclock.git
Vcs-Browser: https://salsa.debian.org/debian/xdaliclock
Rules-Requires-Root: no

Package: xdaliclock
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Melting digital clock
 The xdaliclock program displays a digital clock; when a digit changes, it
 "melts" into its new shape.
 .
 It can display in 12 or 24 hour modes, and displays the date when a mouse
 button is held down. It has two large fonts built into it, but it can animate
 most other fonts that contain all of the digits. It can also do some funky
 psychedelic colormap cycling, and can use the "shape" extension so that the
 window is shaped like the digits.
