=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

override_dh_auto_configure:
	cd X11 && ( CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" ./configure \
		--host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) \
		--prefix=/usr --mandir=/usr/share/man )

override_dh_auto_build:
	cd X11 && $(MAKE) CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)"

override_dh_auto_clean:
	[ ! -f X11/Makefile ] || ( cd X11 && $(MAKE) distclean )

override_dh_auto_install:
	dh_installdirs usr/share/man/man1 usr/bin
	cd X11 && $(MAKE) install_prefix=$(CURDIR)/debian/xdaliclock install

%:
	dh $@ --with autoreconf
