## xdaliclock 2.46

=== Makefile ===
--- 
+++ 
@@ -1,61 +1,58 @@
-# xdaliclock, Copyright (c) 1991-2006 by Jamie Zawinski.
+# xdaliclock, Copyright (c) 1991-2022 by Jamie Zawinski.
 
 SHELL		= /bin/sh
 TARFILES	= README Makefile version.h \
-		  config.guess config.sub install-sh \
 		  mac128/README mac128/*.*
 NUMBERS		= font/dalifont*.{gif,png,ai,psd.gz} font/*.{c,xbm}
-TAR		= tar
+TAR		= gnutar
+TAR_ARGS	= --owner=0 --group=0 --posix --no-acls --no-xattrs --no-selinux
 
 
 default:
 	@echo ''; \
-	 echo '        please make one of: "x", "palm", "webos", "android", "all", or "clean"'; \
+	 echo '        please make one of: "x", "osx", "palm", "webos", "android", "all", or "clean"'; \
 	 echo ''; \
 	 exit 5
 
 all:: OSX webos palm X11 android
 
-X11::   x11
-X::     X11
-x::     X11
-gtk::   GTK
-OSX::   osx
-palm::  Palm
-webos:: WebOS
-android:: Android
-
-x11:: X11/Makefile
+x::     _x11
+osx::   _osx
+palm::  _Palm
+webos:: _WebOS
+android:: _Android
+
+_x11:: X11/Makefile
 	@echo '==============================================================='
 	@echo ''
 	cd X11 ; make
 
-GTK:: gtk/Makefile
-	@echo '==============================================================='
-	@echo ''
-	cd gtk ; make
-
-osx::
+_classic:: X11/Xlib-classic/Makefile
+	@echo '==============================================================='
+	@echo ''
+	cd X11/Xlib-classic ; make
+
+_osx::
 	@echo '==============================================================='
 	@echo ''
 	cd OSX ; make
 
-Palm:: palm/Makefile
+_Palm:: palm/Makefile
 	@echo '==============================================================='
 	@echo ''
 	cd palm ; make
 
-WebOS:: webos/Makefile
+_WebOS:: webos/Makefile
 	@echo '==============================================================='
 	@echo ''
 	cd webos ; make
 
-pebble::
+_pebble::
 	@echo '==============================================================='
 	@echo ''
 	cd pebble ; pebble build
 
-Android:: android/Makefile
+_Android:: android/Makefile
 	@echo '==============================================================='
 	@echo ''
 	cd android ; make
@@ -65,10 +62,10 @@
 	@echo ''
 	cd X11 ; ./configure
 
-gtk/Makefile:
-	@echo '==============================================================='
-	@echo ''
-	cd gtk ; ./configure
+X11/Xlib-classic/Makefile:
+	@echo '==============================================================='
+	@echo ''
+	cd X11/Xlib-classic ; ./configure
 
 palm/Makefile:
 	@echo '==============================================================='
@@ -77,16 +74,16 @@
 
 clean: X11/Makefile palm/Makefile
 	cd X11 ; make $@
-	cd gtk ; make $@
+	cd X11/Xlib-classic ; make $@
 	cd OSX ; make $@
 	cd palm ; make $@
 	cd webos ; make $@
 	cd pebble ; make $@
 	cd android ; make $@
 
-distclean: X11/Makefile gtk/Makefile palm/Makefile
+distclean: X11/Makefile X11/Xlib-classic/Makefile palm/Makefile
 	cd X11 ; make $@
-	cd gtk ; make $@
+	cd X11/Xlib-classic ; make $@
 	cd OSX ; make $@
 	cd palm ; make $@
 	cd webos ; make $@
@@ -118,18 +115,18 @@
 apk::
 	cd android ; $(MAKE) apk
 
-tar: X11/Makefile gtk/Makefile palm/Makefile apk _tar
+tar: X11/Makefile X11/Xlib-classic/Makefile palm/Makefile apk _tar
 _tar:
 	@								    \
-  for dir in X11 gtk palm ; do						    \
+  for dir in X11 X11/Xlib-classic palm ; do				    \
    ( cd $$dir ;								    \
-     rm -f configure ;							    \
-     autoconf263 ;							    \
+     echo "#### $$dir" ;						    \
+     echo rm -f configure ;						    \
+     echo autoconf263 ;							    \
      ./config.status ;							    \
-     $(MAKE) distdepend );						    \
+     echo $(MAKE) distdepend );						    \
   done ;								    \
   (cd X11; $(MAKE) update_spec_version) ;				    \
-  (cd gtk; $(MAKE) update_spec_version) ;				    \
   (cd palm; $(MAKE) update_rsc_version) ;				    \
   (cd webos; $(MAKE) update_release_date) ;				    \
   (cd OSX; $(MAKE) update_plist_version) ;				    \
@@ -138,17 +135,18 @@
   's/[^0-9]*\([0-9]\.[0-9][0-9]*\).*/xdaliclock-\1/p' version.h` ;	    \
   rm -rf $$NAME ; ln -s . $$NAME ;					    \
   FILES= ;								    \
-  for subdir in X11 gtk palm OSX webos pebble android ; do		    \
+  for subdir in X11 X11/Xlib-classic palm OSX webos pebble android ; do	    \
     d=`pwd` ;								    \
     cd $$subdir ;							    \
-    FILES="$$FILES `$(MAKE) echo_tarfiles				    \
+    FILES2="`$(MAKE) echo_tarfiles					    \
       | grep -v '^.*make\['						    \
       | sed \"s|^|$$subdir/|g;s| | $$subdir/|g\"			    \
       ` ";								    \
+    FILES="$$FILES $$FILES2" ;						    \
     cd $$d ; done ;							    \
-  echo creating tar file archive/$${NAME}.tar.gz... ;			    \
+  echo "####" creating tar file archive/$${NAME}.tar.gz... ;		    \
   export COPYFILE_DISABLE=true ;					    \
-  GZIP="-9v" $(TAR) --check-links -vczf archive/$${NAME}.tar.gz		    \
+  GZIP="-9v" $(TAR) --check-links -vczf archive/$${NAME}.tar.gz $(TAR_ARGS) \
     `echo $(TARFILES) $$FILES $(NUMBERS)				    \
    | sed "s|^|$$NAME/|g; s| | $$NAME/|g" ` ;				    \
   rm $$NAME ;								    \
