=== pebble/Makefile ===
# Makefile.in --- xdaliclock, Copyright (c) 1999 Jamie Zawinski.
# the `configure' script generates `Makefile' from this file.

TARFILES = README Makefile appinfo.json wscript \
	   src/*.[ch] \
	   resources/images/*.png

all::
	pebble build

clean::
	-rm -rf build

distclean:: clean
	-rm -f *.bak *.rej *~ "#"*

echo_tarfiles:
	@echo $(TARFILES)
