=== debian/changelog ===
xdaliclock (2.46-1) unstable; urgency=low

  * New upstream release.
  * debian/rules:
    + Drop unnecessary dependency on dh-autoreconf.
    + Updated for upstream changes. Thanks Barak A. Pearlmutter.
  * debian/patches:
    + Dropped cross.patch, obsolete now.
    + Added patches from Barak A. Pearlmutter:
      + 0001-autotools.patch: Fix upstream autotools scripts.
      + 0003-spelling.patch: Fix typos.
  * Removed debian/menu, obsolete now.
  * Updated Build-Deps.
  * Updated debian/copyright.

 -- Kartik Mistry <kartik@debian.org>  Fri, 02 Sep 2022 20:06:40 +0530
