=== debian/control ===
--- 
+++ 
@@ -2,11 +2,10 @@
 Section: x11
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
-               dpkg-dev (>= 1.16.1.1),
-               libx11-dev,
-               libxext-dev,
-               libxt-dev,
-               x11proto-core-dev
+               libgl-dev,
+               libglib2.0-dev,
+               libgtk-3-dev,
+               pkg-config
 Maintainer: Kartik Mistry <kartik@debian.org>
 Standards-Version: 4.6.1
 Homepage: https://www.jwz.org/xdaliclock/
