## xdaliclock 2.48

=== android/Makefile ===
--- 
+++ 
@@ -34,12 +34,13 @@
 		  $(FONTDIR)/font6.json \
 		  $(FONTDIR)/font7.json \
 
-default: apk
+default:: release
+all: debug release
 
-clean:
+clean::
 	rm -f *.o buildnumbers
 
-gradle_clean:
+gradle_clean::
 	cd $(TARGET); ./gradlew clean
 
 distclean:: clean gradle_clean
@@ -99,61 +100,48 @@
 $(FONTDIR)/font7.json:
 	./buildnumbers 7 > $@
 
-all:: $(NUMBERS)
+_deps:: update_gradle_version update_gradle_app_id check_android_home
+debug::   $(NUMBERS) ../version.h _deps
+release:: $(NUMBERS) ../version.h _deps
+debug::
+	cd $(TARGET) && ./gradlew assembleDebug
+release::
+	cd $(TARGET) && ./gradlew assembleRelease
 
 
-# Create my-keystore.keystore with:
-#   keytool -genkey -v -keystore my-keystore.keystore -alias daliclock \
-#           -keyalg RSA -keysize 2048 -validity 10000
-# Keep that file secret!  It is your private key.
-# You can of course use any existing keystore if you already have one.
+KEYSTORE = my-keystore.keystore
+$(KEYSTORE):
+	keytool -genkey -v -keystore $@ \
+	-alias daliclock -keyalg RSA -keysize 2048 -validity 10000
 
-sign: get_zipalign
+APK_DIR       = daliclock/app/build/outputs/apk/release/
+APK_UNSIGNED  = $(APK_DIR)app-release-unsigned.apk
+APK_SIGNED    = $(APK_DIR)app-release.apk
+
+  TOOLDIR = $(shell ls -d $$HOME/Library/Android/sdk/build-tools/* | tail -1)
+ ZIPALIGN = $(TOOLDIR)/zipalign
+APKSIGNER = $(TOOLDIR)/apksigner
+
+sign_release::
+	rm -f $(APK_SIGNED)
+	$(ZIPALIGN) -v 4 $(APK_UNSIGNED) $(APK_SIGNED)
+	$(APKSIGNER) sign --ks $(KEYSTORE) $(APK_SIGNED)
+	$(APKSIGNER) verify $(APK_SIGNED)
+	@ls -lF $(APK_SIGNED)
+	stty -echo
+
+apk:: release
 	@\
-  if [ ! -f "$(CERT)" ]; then						\
-    /bin/echo "$(CERT) does not exist! Generate one. See Makefile." ;	\
-    exit 1 ;								\
+  SRC=../version.h ;							    \
+  VERS=`sed -n 's/[^0-9]*\([0-9]\.[0-9][^. \"]*\).*/\1/p' < $$SRC |	    \
+	sed 's/\.//g' | head -1`;					    \
+  HEAD="DaliClock-$$VERS" ;						    \
+  if [ ! -s $(APK_SIGNED) -o $(APK_UNSIGNED) -nt $(APK_SIGNED) ]; then	\
+    $(MAKE) sign_release ;						\
   fi ;									\
-  /bin/echo -n "Signing  \"$(APK)\"... " ;				\
-  STAGE=sign-$$$$ ;							\
-  rm -rf $$STAGE ;							\
-  mkdir $$STAGE ;							\
-  cd $$STAGE ;								\
-  mv ../$(TARGET)/app/build/outputs/apk/app-release-unsigned.apk ./$(APK); \
-  jarsigner -verbose -sigalg SHA1withRSA -digestalg SHA1 -keystore ../$(CERT) \
-    $(APK) $(TARGET2);							\
-  if [ ! -f "$(ZIPALIGN)" ]; then					\
-    /bin/echo "Cannot find zipalign in build-tools:"; 			\
-    /bin/echo "$(ZIPALIGN)"; 						\
-    /bin/echo "As ANDROID_HOME is valid, please check you have got the build-tools defined in"; \
-    /bin/echo "$(TARGET)/app/build.gradle";				\
-    /bin/echo "Or make build-tools part of your PATH variable";		\
-    /bin/echo "";							\
-    /bin/echo "The created apk will still work, but it might use more memory than neccessary!"; \
-    mv $(APK) ../$(APK);						\
-  else									\
-    $(ZIPALIGN) -v 4 $(APK) $(APK).aligned; 				\
-    mv $(APK).aligned ../$(APK) ;					\
-  fi ;									\
-  cd .. ;								\
-  rm -rf $$STAGE ;							\
-  mv $(APK) ../archive/"$(APK)" ;					\
-  ls -ldhgF ../archive/"$(APK)" ;					\
+  set -x ;								\
+  cp -p $(APK_SIGNED) ../archive/$$HEAD.apk
 
-
-get_zipalign:
-  ifndef ZIPALIGN
-    ZIPALIGN = $(shell which zipalign 2>&- )
-  endif
-  ifeq ($(strip $(ZIPALIGN)),)
-    ZIPALIGN = $(ANDROID_HOME)/build-tools/$(TOOLS_VERSION)/zipalign
-  endif
-
-
-apk: apk_raw sign
-
-apk_raw: $(NUMBERS) ../version.h update_gradle_version update_gradle_app_id check_android_home
-	cd $(TARGET); ./gradlew assembleRelease
 
 check_android_home:
   ifndef ANDROID_HOME
