=== debian/changelog ===
xdaliclock (2.48-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:37:04 +1100

xdaliclock (2.48-1build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 08:09:11 +0000

xdaliclock (2.48-1) unstable; urgency=medium

  * New upstream release
    - Fixes memory leak in X11 code
  * New maintainer (Closes: #1052300)
  * Bump Standards-Version to 4.6.2 (no changes needed)
  * Build-depends on pkgconf instead of pkg-config
  * d/copyright: Add stanza for OSX/Sparkle.framework
  * d/p/0001-autotools.patch: Reworked so autoreconf works
  * d/rules: Build with autoreconf

 -- Tormod Volden <debian.tormod@gmail.com>  Wed, 21 Feb 2024 18:46:48 +0100

xdaliclock (2.47-1) UNRELEASED; urgency=low

  * New upstream release.
  * debian/control:
    + Updated Build-Deps.

 -- Kartik Mistry <kartik@debian.org>  Sat, 03 Sep 2022 10:37:36 +0530
