=== debian/control ===
--- 
+++ 
@@ -5,9 +5,10 @@
                libgl-dev,
                libglib2.0-dev,
                libgtk-3-dev,
-               pkg-config
-Maintainer: Kartik Mistry <kartik@debian.org>
-Standards-Version: 4.6.1
+               pkgconf
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Tormod Volden <debian.tormod@gmail.com>
+Standards-Version: 4.6.2
 Homepage: https://www.jwz.org/xdaliclock/
 Vcs-Git: https://salsa.debian.org/debian/xdaliclock.git
 Vcs-Browser: https://salsa.debian.org/debian/xdaliclock
